# Turn off debuginfo package
%define debug_package %{nil}

Summary:	Utility for creating network bootable images
Name:		mknbi
Version:	1.4.4
Release:	11%{?dist}
URL:		http://etherboot.sourceforge.net/
License:	GPLv2+
Source0:	http://downloads.sourceforge.net/sourceforge/etherboot/%{name}-%{version}.tar.gz
Patch0:		mknbi-1.4.4-gcc4.patch
Patch1:		mknbi-1.4.4-makefile.patch
Patch2:		mknbi-1.4.4-m32.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Group:		Applications/System
BuildRequires:	nasm
BuildRequires:	/usr/include/gnu/stubs-32.h
BuildRequires:  perl
ExclusiveArch:  i386 x86_64

%description
Utility that accompanies Etherboot for making tagged images from ROM
images, Linux kernels, FreeDOS and DOS bootable floppy images.

### IMPORTANT NOTES about mknbi ###
# 1. $RPM_OPT_FLAGS is not used because the binary output of this package is 
#    meant to run in a boot-loader.  This software is tested and proven using
#    the upstream supplied build flags.  Using other flags might be fragile or
#    entirely wrong.
# 2. For this same reason, no debuginfo is created.  debuginfo is not usable by
#    standard tools.  If mknbi is to be debugged, then use a custom build.
# 3. This package contains 32bit x86 code in both the i386 and x86_64 package,
#    similar to memtest86+.  This was done primarily because it is easier to 
#    handle in the buildsystem.
# 4. Everything is placed in /usr/lib/mknbi only because upstream does it this
#    way, and it would be too much work to change it.


%prep
%setup -q
%patch0 -p0
%patch1 -p0
%patch2 -p1

# Filter unwanted Provides: perl*
cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
  sed -e '/perl/d'
EOF

%define __perl_provides %{_builddir}/%{name}-%{version}/%{name}-prov
chmod +x %{__perl_provides}

# Filter corresponding unwanted Requires provided by internal modules
cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
  sed -e '/perl(Elf)/d' -e '/perl(Nbi)/d' -e '/perl(TruncFD)/d'
EOF

%define __perl_requires %{_builddir}/%{name}-%{version}/%{name}-req
chmod +x %{__perl_requires}

%build
make realclean
make PREFIX=%{_prefix}

%install
rm -rf $RPM_BUILD_ROOT
make BUILD_ROOT="$RPM_BUILD_ROOT" PREFIX=%{_prefix} \
	MANDIR=$RPM_BUILD_ROOT%{_mandir}/man1 \
	BINDIR=$RPM_BUILD_ROOT%{_bindir} \
	RPMVERSION="$RPM_PACKAGE_VERSION" INSTALL='install -p' install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc mknbi.html
# /usr/lib is needed even on x86_64, do not macroize
%{_prefix}/lib/mknbi/
%{_bindir}/*
%{_mandir}/man1/*
%doc COPYING LOG README spec.txt

%changelog
* Tue Oct 30 2007 Warren Togami <wtogami@redhat.com> 1.4.4-11
- filter out corresponding perl* provides

* Mon Oct 29 2007 Warren Togami <wtogami@redhat.com> 1.4.4-10
- fix source timestamp
- filter out perl* provides

* Mon Oct 29 2007 Warren Togami <wtogami@redhat.com> 1.4.4-9
- Fix Source0
- GPLv2+
- add some comments

* Mon Oct 29 2007 Warren Togami <wtogami@redhat.com> 1.4.4-8
- Remove Vendor tag
- mknbi.html in %%doc
- Do not create (empty) debuginfo package
- add suggested flags to make install

* Thu Oct 25 2007 Warren Togami <wtogami@redhat.com> 1.4.4-6
- more spec cleanups

* Fri Oct 19 2007 Warren Togami <wtogami@redhat.com> 1.4.4-5
- Not noarch
- Fix build and make ExclusiveArch: i386 x86_64
- more cleanups

* Sun Oct 14 2007 Eric Harrison <eharrison@mesd.k12.or.us> 1.4.4-4
- more spec file clean-ups
  fix directory ownership

* Sun Oct 14 2007 Eric Harrison <eharrison@mesd.k12.or.us> 1.4.4-3
- bumped release number, Fedora Extras 4 included an i386-only 1.4.4-2
  gcc4 patches written by "Dams Nade" (anvil)
  spec file clean-ups

* Mon Aug 16 2004 Ken Yap <ken_yap@users.sourceforge.net>
- Merge patches from Isac, and Michael Brown pertaining to padding
  of initrds and memdisk images.
  Merge patch to menu-simple.c from isac.
  Merge corrected algorithm for calculating used sectors from isac.

* Wed Aug 11 2004 Ken Yap <ken_yap@users.sourceforge.net>
- Fix to provide memcmp as newer gcc's don't. Fixed up path of
  documentation directory.

* Fri Jun  4 2004 Oron Peled <oron@actcom.co.il>
- Fixes to mknbi.spec:
  Add defattr for non-root builds
  Clean install directory before make install.
  Use directory macros -- _bindir et al.
  Make mknbi a relocateable package -- add Prefix tag

* Thu Dec 04 2003 Ken Yap <ken_yap@users.sourceforge.net>
- Release to fix serious error in first32.c.

* Sat Aug 09 2003 Ken Yap <ken_yap@users.sourceforge.net>
- Menu program was broken, didn't do ANSI escapes.

* Fri Jul 18 2003 Ken Yap <ken_yap@users.sourceforge.net>
- Bug fixes to 1.4.0. Support for larger disks in DOS.

* Wed Jan 15 2003 Ken Yap <ken_yap@users.sourceforge.net>
- New series 1.4. Downloadable Lua interpreter.

* Sat Dec 28 2002 Ken Yap <ken_yap@users.sourceforge.net>
- Merged in changes by Eric Biederman to compute and store a checksum
  in image. Ready for ELF parameter passing convention.

* Sat Nov 30 2002 Masaru Kawashima <masaruk@gol.com>
- Modified mknbi.spec mainly to include /usr/lib/mknbi/menu and COPYING

* Sun Oct 20 2002 Ken Yap <ken_yap@users.sourceforge.net>
- Fixed start32.S to not rely on where it's called from, essential
  for booting from Etherboot 5.1+. For this we have to switch GDT
  like startmenu.S does.

* Thu Aug 15 2002 Ken Yap <ken_yap@users.sourceforge.net>
- Robb Main contributed an enhanced menu implementation, mknbi-nfl

* Fri Jul 05 2002 Ken Yap <ken_yap@users.sourceforge.net>
- Add an EXTRAVERSION to Makefile, to be printed out by first32.c.
- Modified call to int15h/e801 in start32.S to check for return values
  in CX, DX in case BIOS doesn't return them in AX, BX.
- Ported internal menu program from Etherboot to be external menu
program for mknbi-menu.
- Updated URL for FreeDOS kernel sources.

* Wed Mar 20 2002 Ken Yap <ken_yap@users.sourceforge.net>
- Add E820H memory sizing routines.
- Don't put ramdisk higher than larger of 896MB and setup.S:ramdisk_max

* Thu Jan 15 2002 Ken Yap <ken_yap@users.sourceforge.net>
- Provide Netboot boot block as altboot.bin

* Thu Nov 15 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Implement --rdbase for mknbi-fdos and mknbi-dos to specify starting
  address of ramdisk (floppy image).
- Make first.*dos depend on Makefile so that the version signature gets
  updated when the version is updated.
- Print some friendly advice if --ip is not specified and there is no
  ramdisk argument (i.e. probably needs NFSroot).
- Shuffle segments to make more space for parameters and first32. This
  version and future versions may not work with Etherboot images that have
  been compiled with BOOTP_DATA_AT_0x93Cxx. (There is some reprieve due to
  first32.c not using all 6kB of the allocated room yet, but that space
  may be used some day.)
- Implement interception and decoding of the mem= kernel parameter to
  use as top of memory for the purpose of relocating the ramdisk.

* Sun Sep 20 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Small fixes to allow make -j, print a warning if zImage is too large,
  and implement --disableharddisk option.

* Thu Aug 02 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Parameters passed to kernel are duplicated due to extra lines in mknbi.pl,
  remove one set of lines.
- Use new (s)printf that has no buffer and thus no limit on stdout length per
  call.

* Sat Jul 28 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Implement --rdbase to control ramdisk load address.
- Implement missing VENDOR_SELECTION feature per spec.
- Merged in support for --rootmode=rw|ro.
- Minor documentation updates

* Sun Jun 03 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Forgot to update consistency checking code in mknbi-*dos to take into
  account full version number.
- Moving Etherboot to 0x94000 broke mknbi-fdos because setup segment was at
  0x97000. Move setup segment to 0x93000. Actually ($reloc + 0x300) * 16.

* Fri May 04 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Support setup.S version 0x0202, put version in vendortag
- Derive version number of mknbi.pl and first32.c from VERSION in Makefile.
- Replace 0x9000 by $relocseg, and add support for placement of Linux segments at 0x90000 and 0x80000 upwards.
- Makefile now makes 2 more versions of first32{,pm,elf}.linux for placement at 0x92200 and 0x82200.

* Sun Apr 08 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Make this a production release.

* Sun Mar 11 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Development release. Unpack format fix in Perl code. Pass drive number
  to DOS. Update memory map comments in first32.c.

* Thu Feb 08 2001 Ken Yap <ken_yap@users.sourceforge.net>
- Development release. New binary stubs in C, for protected mode, for ELF,
  for menu. Little fixes in Perl code.

* Wed Nov 29 2000 Ken Yap <ken_yap@users.sourceforge.net>
- Fixed bug in first-linux.S, don't use ROM values for missing parameters

* Sat Nov 11 2000 Ken Yap <ken_yap@users.sourceforge.net>
- Fixed bug in first-linux.S, don't use tftp root dir as fallback for rootpath
- Added --nosquash option in case TruncFD doesn't work

* Mon Aug 07 2000 Ken Yap <ken_yap@users.sourceforge.net>
- Added disdosbb. Fixed last cluster bug. --harddisk now works for DOS

* Sun Jul 30 2000 Ken Yap <ken_yap@users.sourceforge.net>
- Fix in ramdisk moving in first-linux.S. --harddisk now works for FreeDOS

* Sun Jul 23 2000 Ken Yap <ken_yap@users.sourceforge.net>
- Added rmrd.S to directory

* Mon May 08 2000 Ken Yap <ken_yap@users.sourceforge.net>
- Fixed a few option bugs and improved man page explanation

* Wed Apr 26 2000 Ken Yap <ken_yap@users.sourceforge.net>
- Production release

* Sat Apr 15 2000 Ken Yap <ken_yap@users.sourceforge.net>
- Initial release

